#include<iostream>
using namespace std;
int main(){
    long long N, a, b, z;
    cin>>N>>a>>b;
    long long p[N], cifra[3];
    p[0]=a;
    p[1]=b;
    for(int i=0; i<N-1; i++){
        z=p[i]*p[i+1];
        p[i+2]=z%1000;
        cifra[1]=p[i+2]%10;
        cifra[2]=(p[i+2]/10)%10;
        cifra[3]=p[i+2]/100;
        for(int i=3; i>0; i--){
            if(cifra[i]==0){
                cifra[i]=9;
            }else{
                cifra[i]=cifra[i]-1;
            }
        }
        p[i+2]=cifra[1]*1+cifra[2]*10+cifra[3]*100;
    }
    cout<<p[N-1];
return 0;
}
